diff options
author | Colin Walters <walters@verbum.org> | 2005-03-12 16:33:01 +0000 |
---|---|---|
committer | Colin Walters <walters@verbum.org> | 2005-03-12 16:33:01 +0000 |
commit | 3dea5c183f65c3f924fb442bf606dfeb50f028a4 (patch) | |
tree | 0ac180fdc5c7766d003863717ef6cbeff8237806 /test/glib/run-test.sh | |
parent | 3c1d2d65654f92f24d3e5c9c5b88d76a10f72822 (diff) |
2005-03-11 Colin Walters <walters@verbum.org>
* glib/Makefile.am: Generate dbus-glib-bindings.h and
install it.
* bus/print-introspect.c: New file; prints introspection
data for a given name and object path.
* bus/run-with-tmp-session-bus.sh: New file, refactored
from test/glib/run-test.sh. Creates a temporary session
bus and runs another program.
* test/glib/run-test.sh: Refactor to invoke
run-with-tmp-session-bus.sh.
* bus/driver.c (bus_driver_handle_introspect): Fix to print new
introspection format. Also change to use DBUS_TYPE_x_AS_STRING
macros instead of hardcoding.
* glib/.cvsignore, bus/.cvsignore, test/glib/.cvsignore: Update.
Diffstat (limited to 'test/glib/run-test.sh')
-rwxr-xr-x | test/glib/run-test.sh | 68 |
1 files changed, 7 insertions, 61 deletions
diff --git a/test/glib/run-test.sh b/test/glib/run-test.sh index cf0a85fc..51d4a713 100755 --- a/test/glib/run-test.sh +++ b/test/glib/run-test.sh @@ -3,59 +3,16 @@ SCRIPTNAME=$0 MODE=$1 -function die() -{ - if ! test -z "$DBUS_SESSION_BUS_PID" ; then - echo "killing message bus "$DBUS_SESSION_BUS_PID - kill -9 $DBUS_SESSION_BUS_PID - fi - echo $SCRIPTNAME: $* >&2 - exit 1 -} - -if test -z "$DBUS_TOP_BUILDDIR" ; then - die "Must set DBUS_TOP_BUILDDIR" -fi - -## convenient to be able to ctrl+C without leaking the message bus process -trap 'die "Received SIGINT"' SIGINT - -CONFIG_FILE=./run-test.conf -SERVICE_DIR="$DBUS_TOP_BUILDDIR/test/data/valid-service-files" -ESCAPED_SERVICE_DIR=`echo $SERVICE_DIR | sed -e 's/\//\\\\\\//g'` -echo "escaped service dir is: $ESCAPED_SERVICE_DIR" - -## create a configuration file based on the standard session.conf -cat $DBUS_TOP_BUILDDIR/bus/session.conf | \ - sed -e 's/<servicedir>.*$/<servicedir>'$ESCAPED_SERVICE_DIR'<\/servicedir>/g' | \ - sed -e 's/<include.*$//g' \ - > $CONFIG_FILE - -echo "Created configuration file $CONFIG_FILE" - -export PATH=$DBUS_TOP_BUILDDIR/bus:$PATH -## the libtool script found by the path search should already do this, but -export LD_LIBRARY_PATH=$DBUS_TOP_BUILDDIR/dbus/.libs:$LD_LIBRARY_PATH - -## will only do anything on Linux -export MALLOC_CHECK_=2 - -unset DBUS_SESSION_BUS_ADDRESS -unset DBUS_SESSION_BUS_PID - -echo "Using daemon "`type dbus-daemon` - -eval `$DBUS_TOP_BUILDDIR/tools/dbus-launch --sh-syntax --config-file=$CONFIG_FILE` - -if test -z "$DBUS_SESSION_BUS_PID" ; then - die "Failed to launch message bus for tests to run" -fi - -echo "Started test bus pid $DBUS_SESSION_BUS_PID at $DBUS_SESSION_BUS_ADDRESS" - ## so the tests can complain if you fail to use the script to launch them export DBUS_TEST_GLIB_RUN_TEST_SCRIPT=1 +# Rerun ourselves with tmp session bus if we're not already +if test -z "$DBUS_TEST_GLIB_IN_RUN_TEST"; then + DBUS_TEST_GLIB_IN_RUN_TEST=1 + export DBUS_TEST_GLIB_IN_RUN_TEST + exec $DBUS_TOP_BUILDDIR/bus/run-with-tmp-session-bus.sh $SCRIPTNAME $MODE +fi + if test x$MODE = xprofile ; then echo "profiling type $PROFILE_TYPE" sleep 2 ## this lets the bus get started so its startup time doesn't affect the profile too much @@ -77,14 +34,3 @@ else echo "running test-dbus-glib" libtool --mode=execute $DEBUG $DBUS_TOP_BUILDDIR/test/glib/test-dbus-glib || die "test-dbus-glib failed" fi - -## we kill -TERM so gcov data can be written out - -kill -TERM $DBUS_SESSION_BUS_PID || die "Message bus vanished! should not have happened" && echo "Killed daemon $DBUS_SESSION_BUS_PID" - -sleep 2 - -## be sure it really died -kill -9 $DBUS_SESSION_BUS_PID > /dev/null 2>&1 || true - -exit 0 |